<?php

namespace FiloBlu\Refilo\Remote\Entity\Provider;

use FiloBlu\Refilo\Remote\Entity\EntityProviderInterface;

/**
 * Class AbstractFromCollectionProvider
 * @package FiloBlu\Refilo\Remote\Entity\Provider
 */
abstract class AbstractFromCollectionProvider implements EntityProviderInterface
{
    /**
     * @var int
     */
    protected $pageSize = 1000;
    /**
     * @var array
     */
    protected $items = [];

    public function next()
    {
        return next($this->items);
    }

    /**
     * @return bool|float|int|string|null
     */
    public function key()
    {
        return current($this->items)->getId();
    }

    public function valid()
    {
        if ($this->getCollection()->getCurPage() < $this->getCollection()->getLastPageNumber()) {
            if (current($this->items) !== false) {
                return true;
            }

            $this->items = $this->getCollection()
                ->clear()
                ->setCurPage($this->getCollection()->getCurPage() + 1)
                ->getItems();
            return true;
        }

        return current($this->items) !== false;
    }

    abstract public function getCollection();

    /**
     *
     */
    public function rewind()
    {
        $this->items = $this->getCollection()
            ->clear()
            ->setPageSize($this->pageSize)
            ->setCurPage(1)
            ->getItems();
    }
}
